diff --git a/lib/table.c b/lib/table.c
index 3bf93894ec0b..02cfde3be393 100644
--- a/lib/table.c
+++ b/lib/table.c
@@ -324,6 +324,12 @@ struct route_node *route_node_get(struct route_table *table,
 	table->count++;
 	route_lock_node(new);
 
+	if (p->family == AF_FLOWSPEC){
+		void *temp;
+		temp = (void *)p->u.prefix_flowspec.ptr;
+		XFREE(MTYPE_TMP, temp);
+	}
+
 	return new;
 }
 
